<template>
  <div>
    <v-toolbar flat>
      <v-toolbar-title class="primary--text"
        >Add New Appointment</v-toolbar-title
      >
    </v-toolbar>
    <v-row class="px-5">
      <v-col cols="12" md="6" sm="12">
        <v-alert border="left" color="primary" dark>
          <span v-if="drive == null">
            Please click drop a pin on the map to mark your appointment location
          </span>
          <span v-else-if="!calculationdone"> Calculating </span>
          <span v-else>
            Drive: <strong>{{ drive.text }}</strong> Destince
            <strong>{{ distance.text }}</strong></span
          >
        </v-alert>
        <div id="map" style="width: 100%;height: 100%;"></div>
      </v-col>
      <v-col cols="12" md="6" sm="12">
        <h3>Appointment Details</h3>
        <v-autocomplete
          v-model="appointment.agent"
          :items="agentlist"
          :filter="agentfilter"
          label="Select Agent"
          item-text="name"
          item-value="id"
        >
          <template v-slot:selection="data">
            <v-avatar
              size="30"
              class="white--text mr-3 py-3"
              color="primary"
              dark
              >{{ data.item.fields.agent_name.charAt(0)
              }}{{ data.item.fields.agent_surname.charAt(0) }} </v-avatar
            >{{ data.item.fields.agent_name }}
            {{ data.item.fields.agent_surname }}
          </template>
          <template v-slot:item="data">
            <v-avatar size="35" class="white--text mr-3" color="primary" dark
              >{{ data.item.fields.agent_name.charAt(0)
              }}{{ data.item.fields.agent_surname.charAt(0) }} </v-avatar
            >{{ data.item.fields.agent_name }}
            {{ data.item.fields.agent_surname }}
          </template>
        </v-autocomplete>
        <v-row>
          <v-col>
            <v-menu
              v-model="showcal"
              :close-on-content-click="false"
              :nudge-right="40"
              transition="scale-transition"
              offset-y
              min-width="auto"
            >
              <template v-slot:activator="{ on, attrs }">
                <v-text-field
                  v-model="date"
                  label="Appointment Date"
                  readonly
                  v-bind="attrs"
                  v-on="on"
                ></v-text-field>
              </template>
              <v-date-picker
                v-model="date"
                @input="showcal = false"
              ></v-date-picker>
            </v-menu>
          </v-col>
          <v-col>
            <v-menu
              ref="timeselector"
              v-model="showtime"
              :close-on-content-click="false"
              :nudge-right="40"
              :return-value.sync="time"
              transition="scale-transition"
              offset-y
            >
              <template v-slot:activator="{ on, attrs }">
                <v-text-field
                  v-model="time"
                  label="Appointment Time"
                  readonly
                  v-bind="attrs"
                  v-on="on"
                ></v-text-field>
              </template>
              <v-time-picker
                v-if="showtime"
                v-model="time"
                full-width
                @click:minute="$refs.timeselector.save(time)"
              ></v-time-picker>
            </v-menu>
          </v-col>
        </v-row>
        <h3>Contact Details</h3>
        <v-combobox
          @change="autofill"
          label="First Name"
          :filter="clientfilter"
          :items="clients"
          v-model="appointment.first_name"
        >
          <template v-slot:item="data">
            {{ data.item.fields.contact_name }}
            {{ data.item.fields.contact_surname }}
          </template>
        </v-combobox>
        <v-text-field label="Surname" v-model="appointment.last_name" />
        <v-text-field label="Email" v-model="appointment.email" />
        <v-text-field
          type="number"
          label="Phone Number"
          v-model="appointment.phone"
        />
        <v-btn
          :disabled="!isFormValid"
          block
          color="primary"
          elevation="0"
          @click="submit"
          >Create Appointment</v-btn
        >
      </v-col>
    </v-row>
    <v-snackbar v-model="snackbar" timeout="2000">
      {{ message }}

      <template v-slot:action="{ attrs }">
        <v-btn color="blue" text v-bind="attrs" @click="snackbar = false">
          Close
        </v-btn>
      </template>
    </v-snackbar>
  </div>
</template>
<script>
export default {
  name: "appointments",
  components: {},
  data: () => ({
    map: null,
    mapCenter: { lat: 51.729157, lng: 0.478027 },
    drive: null,
    distance: null,
    calculationdone: false,
    agentlist: [],
    clients: [],
    selectedclient: null,
    appointment: {
      agent: null,
      code: "",
      first_name: "",
      last_name: "",
      email: "",
      phone: "",
    },
    date: new Date().toISOString().substr(0, 10),
    showcal: false,
    showtime: false,
    time: null,
    search: "",
    status: null,
    snackbar: false,
    message: "",
  }),
  async created() {
    this.agentlist = await this.$agent.getAgents();
    this.clients = await this.$client.getClients();
  },
  mounted() {
    this.initMap();
  },
  computed: {
    isFormValid() {
      return (
        this.appointment.code != "" &&
        this.appointment.first_name != "" &&
        this.appointment.last_name != "" &&
        this.appointment.email != "" &&
        this.appointment.phone != "" &&
        this.appointment.agent != null
      );
    },
  },
  methods: {
    async submit() {
      let payload = {};
      payload = {};
      payload.contact_id = [];
      if (this.selectedclient) {
        payload.contact_id.push(this.selectedclient.id);
      } else {
        let record = {};
        record.contact_name = this.appointment.first_name;
        record.contact_surname = this.appointment.last_name;
        record.contact_email = this.appointment.email;
        record.contact_phone = this.appointment.phone;
        payload.contact_id.push(await this.$client.createClient(record));
      }
      payload.agent_id = [];
      payload.agent_id.push(this.appointment.agent);
      payload.appointment_postcode = this.appointment.code;
      payload.appointment_date = this.date + "T" + this.time + ":00.000Z";

      this.status = await this.$appointment.createAppointment(payload);
      if (this.status == 200) {
        this.message = "Appointment Added Successfully";
        this.snackbar = true;
        this.appointment = {
          agent: null,
          code: "",
          first_name: "",
          last_name: "",
          email: "",
          phone: "",
        };
        this.selectedclient = null;
        this.date = new Date().toISOString().substr(0, 10);
        this.time = null;
      } else {
        this.message = "A Problem Adding Appointments";
        this.snackbar = true;
      }
    },
    autofill(e) {
      if (e) {
        console.log("autofill this", e);
        this.appointment.first_name = e.fields.contact_name;
        this.appointment.last_name = e.fields.contact_surname;
        this.appointment.email = e.fields.contact_email;
        this.appointment.phone = e.fields.contact_phone;
        this.selectedclient = e;
      } else {
        this.appointment.last_name = "";
        this.appointment.email = "";
        this.appointment.phone = "";
        this.selectedclient = null;
      }
    },
    initMap() {
      this.$map.load().then(() => {
        this.map = new window.google.maps.Map(document.getElementById("map"), {
          center: this.mapCenter,
          zoom: 13,
          maxZoom: 20,
          minZoom: 3,
          streetViewControl: true,
          mapTypeControl: true,
          zoomControl: true,
        });
        new window.google.maps.Marker({
          position: { lat: 51.729157, lng: 0.478027 },
          map: this.map,
        });
        let applocation = new window.google.maps.Marker();
        applocation.setMap(this.map);
        this.map.addListener("click", async (mapsMouseEvent) => {
          this.calculationdone = false;
          console.log("new location is ", mapsMouseEvent.latLng.toJSON());
          applocation.setPosition(mapsMouseEvent.latLng.toJSON());
          var service = new window.google.maps.DistanceMatrixService();
          service.getDistanceMatrix(
            {
              origins: [this.mapCenter],
              destinations: [mapsMouseEvent.latLng],
              travelMode: "DRIVING",
            },
            this.distanceResult
          );
        });
      });
    },
    distanceResult(response, status) {
      console.log("response and status", response, status);
      this.appointment.code = response.destinationAddresses[0]
        .split(",")
        .map((s) => s.trim().match(/([A-Za-z]{1,2}\d{1,2})(\s?(\d?\w{2}))?/))
        .filter((e) => e)[0][0];
      this.distance = response.rows[0].elements[0].distance;
      this.drive = response.rows[0].elements[0].duration;
      this.calculationdone = true;
    },
    agentfilter(agent, queryText) {
      return (
        agent.fields.agent_name
          .toLowerCase()
          .includes(queryText.toLowerCase()) ||
        agent.fields.agent_surname
          .toLowerCase()
          .includes(queryText.toLowerCase())
      );
    },
    clientfilter(client, queryText) {
      return (
        client.fields.contact_name
          .toLowerCase()
          .includes(queryText.toLowerCase()) ||
        client.fields.contact_surname
          .toLowerCase()
          .includes(queryText.toLowerCase())
      );
    },
  },
};
</script>
